## ros-foxy-plansys2-executor 1.0.10

=== CMakeLists.txt ===
project(plansys2_executor)

cmake_minimum_required(VERSION 3.5)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

find_package(Threads REQUIRED)

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rclcpp_cascade_lifecycle REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(plansys2_core REQUIRED)
find_package(plansys2_pddl_parser REQUIRED)
find_package(plansys2_msgs REQUIRED)
find_package(plansys2_domain_expert REQUIRED)
find_package(plansys2_problem_expert REQUIRED)
find_package(plansys2_planner REQUIRED)
find_package(behaviortree_cpp_v3 REQUIRED)
find_package(std_msgs REQUIRED)

find_package(ZMQ)
if(ZMQ_FOUND)
    message(STATUS "ZeroMQ found.")
    add_definitions(-DZMQ_FOUND)
else()
  message(WARNING "ZeroMQ NOT found. Not including PublisherZMQ.")
endif()

set(CMAKE_CXX_STANDARD 17)

set(dependencies
    rclcpp
    rclcpp_lifecycle
    lifecycle_msgs
    rclcpp_cascade_lifecycle
    rclcpp_action
    plansys2_pddl_parser
    ament_index_cpp
    plansys2_core
    plansys2_msgs
    plansys2_domain_expert
    plansys2_problem_expert
    plansys2_planner
    behaviortree_cpp_v3
    std_msgs
)

include_directories(include ${ZMQ_INCLUDE_DIRS})

set(EXECUTOR_SOURCES
  src/plansys2_executor/ExecutorClient.cpp
  src/plansys2_executor/ActionExecutor.cpp
  src/plansys2_executor/ActionExecutorClient.cpp
  src/plansys2_executor/ExecutorNode.cpp
  src/plansys2_executor/BTBuilder.cpp
  src/plansys2_executor/behavior_tree/execute_action_node.cpp
  src/plansys2_executor/behavior_tree/wait_action_node.cpp
  src/plansys2_executor/behavior_tree/wait_atstart_req_node.cpp
  src/plansys2_executor/behavior_tree/check_overall_req_node.cpp
  src/plansys2_executor/behavior_tree/check_atend_req_node.cpp
  src/plansys2_executor/behavior_tree/check_timeout_node.cpp
  src/plansys2_executor/behavior_tree/apply_atstart_effect_node.cpp
  src/plansys2_executor/behavior_tree/apply_atend_effect_node.cpp
)


add_library(${PROJECT_NAME} SHARED ${EXECUTOR_SOURCES})
ament_target_dependencies(${PROJECT_NAME} ${dependencies})
target_link_libraries(${PROJECT_NAME} ${ZMQ_LIBRARIES})

add_executable(executor_node
  src/executor_node.cpp
)
ament_target_dependencies(executor_node ${dependencies})
target_link_libraries(executor_node ${PROJECT_NAME})

install(DIRECTORY include/
  DESTINATION include/
)

install(DIRECTORY launch behavior_trees DESTINATION share/${PROJECT_NAME})

install(TARGETS
  ${PROJECT_NAME}
  executor_node
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)

  add_subdirectory(test)
endif()

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(${dependencies})

ament_package()

=== test/CMakeLists.txt ===
set(TEST_PDDL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/pddl)
set(TEST_BEHAVIOR_TREES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test_behavior_trees)
set(TEST_LAUNCH_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test_launch_files)

install(DIRECTORY
  ${TEST_PDDL_DIR}
  ${TEST_BEHAVIOR_TREES_DIR}
  DESTINATION share/${PROJECT_NAME}
)

add_subdirectory(unit)
#add_subdirectory(integration)

=== test/unit/CMakeLists.txt ===
ament_add_gtest(executor_test executor_test.cpp)
target_compile_definitions(executor_test PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(executor_test ${PROJECT_NAME})

ament_add_gtest(action_execution_test action_execution_test.cpp)
target_compile_definitions(action_execution_test PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(action_execution_test ${PROJECT_NAME})


ament_add_gtest(execution_tree_test execution_tree_test.cpp)
target_compile_definitions(execution_tree_test PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(execution_tree_test ${PROJECT_NAME})
ament_target_dependencies(execution_tree_test ${dependencies})

ament_add_gtest(btbuilder_tests btbuilder_tests.cpp)
target_compile_definitions(btbuilder_tests PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(btbuilder_tests ${PROJECT_NAME})
ament_target_dependencies(btbuilder_tests ${dependencies})

ament_add_gtest(bt_node_test bt_node_test.cpp)
target_compile_definitions(bt_node_test PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(bt_node_test ${PROJECT_NAME})
ament_target_dependencies(bt_node_test ${dependencies})

ament_add_gtest(bt_node_test_charging bt_node_test_charging.cpp)
target_compile_definitions(bt_node_test_charging PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(bt_node_test_charging ${PROJECT_NAME})
ament_target_dependencies(bt_node_test_charging ${dependencies})

=== debian/changelog ===
ros-foxy-plansys2-executor (1.0.10-1focal) focal; urgency=high

  * Minor update
  * Fix tests
  * Fix rate conversions
  * Add rate parameter
  * Remove node parameter in client constructors
  * ros2-plan-msg: Passing plan to executor to add further separation between plan creation and plan execution.
  * Suggestion for #118 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/118>
  * pddl-tree-messages: Performing some minor cleanup.
  * pddl-tree-messages: Using explicit specifier for single parameter constructors in plansys2_core/Types.hpp.
  * pddl-tree-messages: Replacing user access function calls with shorter versions where possible.
  * pddl-tree-messages: Adding predicate user access functions to problem expert client.
  * pddl-tree-messages: Adding predicate user access functions to problem expert client.
  * pddl-tree-messages: Applying ament uncrustify.
  * pddl-tree-messages: Updating addInstance and removeInstance calls to use helper classes.
  * pddl-tree-messages: Reverting change to log statement severity.
  * pddl-tree-messages: Removing a couple unnecessary includes.
  * pddl-tree-messages: Merging master and resolving conflicts.
  * action-timeout-clean: Renaming test behavior tree.
  * Using custom behavior tree to enable action timeouts.
  * pddl-tree-messages: Merging upstream master and resolving conflicts.
  * pddl-tree-messages: Using ROS messages to define the PDDL construct trees.
  * Adding action execution status (as color changes) to the plan dotgraph.
    Adding legend to plan dotgraph, adding node params for dotgraph legend and printing plan graph to terminal.
  * Fix tests and linting
  * linting
  * Configurable action BT
  * Configurable BT Action
  * Reducing log message severity because lack of a plan isn't necessarily an error.
  * Reduce debug output
  * Plansys2_tests package
  * Adding unit test for getOrderedSubGoals.
  * Add GetOrderedSubGoals service to Executor, allowing executor clients to get the order in which sub-goals will be completed by the current plan.
  * Update version
  * Contributors: Alexander Xydes, Francisco Martín Rico, Greg Kogut, Josh Zapf

 -- Francisco Martin Rico <fmrico@gmail.com>  Fri, 02 Jul 2021 22:00:00 -0000

ros-foxy-plansys2-executor (1.0.9-1focal) focal; urgency=high

  * Disable boost in tests
  * Contributors: Francisco Martín Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Sun, 14 Mar 2021 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.8-1focal) focal; urgency=high

  * Change default ZMQ ports
  * Removing whitespace.
  * Simplified logic.
  * Update API for FutureReturnCode
  * Handling edge cases of action failure and preventing overriding completion percentage on action completion.
  * Publishing generated plan as a dotgraph on a string topic.
  * Fix BT creation; parallel deps actions
  * Fixing feedback control
  * Action execution refactoring
  * Moving Utils file to plansys2_problem_expert since all the functions are checking information in the problem or modifying the problem.
  * utils-bug: Fixing bug in OR case of evaluate function in plansys2_executor/Utils.cpp.
  * Making zmq error message more generic to reflect that there are multiple possible reasons for a BT::LogicError to be thrown.
  * Add support to plansys2_executor/ExecutorNode for visualizing the behavior trees in Groot.
  * Moving publisher on_activate call to the ExecutorNode::on_activate callback.
  * Add support for numeric conditions and effects.
  * Monitorization info
  * Remove an unreshable return
  * Adding actor checker in terminal
  * Improving BTActions
  * Fix repeated nodes
  * New Graph creation Algorithm
  * Debugging
  * Added negative predicates support
  * Namespaced action_hub
  * Contributors: Alexander Xydes, Fabrice Larribe, Francisco Martin Rico, Greg Kogut, Josh Zapf

 -- Francisco Martin Rico <fmrico@gmail.com>  Thu, 11 Mar 2021 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.7-1focal) focal; urgency=high

  * Making explicit dependencies
  * Contributors: Francisco Martín Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Sun, 03 Jan 2021 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.6-1focal) focal; urgency=high

  * Disable boost functions
  * Contributors: Francisco Martín Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Mon, 28 Dec 2020 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.5-1focal) focal; urgency=high

  * Migration to c++17
  * Contributors: Francisco Martín Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Sun, 27 Dec 2020 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.4-1focal) focal; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Wed, 23 Dec 2020 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.3-1focal) focal; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Tue, 22 Dec 2020 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.2-1focal) focal; urgency=high

  * Plan solvers as plugins
  * Contributors: Fabrice Larribe, Francisco Martin Rico, f269858

 -- Francisco Martin Rico <fmrico@gmail.com>  Tue, 22 Dec 2020 23:00:00 -0000

ros-foxy-plansys2-executor (1.0.1-1focal) focal; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Sat, 18 Jul 2020 22:00:00 -0000

ros-foxy-plansys2-executor (1.0.0-1focal) focal; urgency=high

  * Foxy initial version
  * Boost:optional
  * Support for BT actions
  * Contributors: Francisco Martin Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Sat, 18 Jul 2020 22:00:00 -0000

ros-foxy-plansys2-executor (0.0.8-1focal) focal; urgency=high

  * Add BT support
  * Contributors: Francisco Martin Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Fri, 17 Jul 2020 22:00:00 -0000

ros-foxy-plansys2-executor (0.0.7-1focal) focal; urgency=high

  * ActionExecutorClient is cascade_lifecycle
    Signed-off-by: Francisco Martin Rico <mailto:fmrico@gmail.com>
  * Contributors: Francisco Martin Rico

 -- Francisco Martin Rico <fmrico@gmail.com>  Wed, 25 Mar 2020 23:00:00 -0000



=== debian/control ===
Source: ros-foxy-plansys2-executor
Section: misc
Priority: optional
Maintainer: Francisco Martin Rico <fmrico@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libzmq3-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-index-cpp, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-behaviortree-cpp-v3, ros-foxy-lifecycle-msgs, ros-foxy-plansys2-core, ros-foxy-plansys2-domain-expert, ros-foxy-plansys2-msgs, ros-foxy-plansys2-pddl-parser, ros-foxy-plansys2-planner, ros-foxy-plansys2-problem-expert, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-rclcpp-cascade-lifecycle, ros-foxy-rclcpp-lifecycle, ros-foxy-std-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-plansys2-executor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libzmq3-dev, ros-foxy-ament-index-cpp, ros-foxy-behaviortree-cpp-v3, ros-foxy-lifecycle-msgs, ros-foxy-plansys2-core, ros-foxy-plansys2-domain-expert, ros-foxy-plansys2-msgs, ros-foxy-plansys2-pddl-parser, ros-foxy-plansys2-planner, ros-foxy-plansys2-problem-expert, ros-foxy-popf, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-rclcpp-cascade-lifecycle, ros-foxy-rclcpp-lifecycle, ros-foxy-std-msgs, ros-foxy-ros-workspace
Description: This package contains the Executor module for the ROS2 Planning System

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-plansys2-executor//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
